{% extends 'base.html' %}

{% block content %}
        <div id="map" style="height: 100%; border-style: groove; border-radius: 22px; border-width: 4px; position: absolute;"></div>
        <script>
            //setView([51.505, -0.09], 13);
            var map = new L.map('map', {zoomControl: false}, center=([20.57, -100.38], zoom=13));
            var user_marker = new L.marker([20.57, -100.38]);
            var user_radial = new L.circle(L.circle(user_marker.latlng));
            //L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {

            //types of markers
            var iconTypes = {
                'bache': '<i class="fas fa-exclamation-triangle"></i>',
                'coladera': '<i class="fas fa-ring"></i>',
                'obra sin terminar': '<i class="far fa-wrench"></i>',
                'escombro': '<i class="far fa-trash-alt"></i>',
                'robo-asalto': '<i class="far fa-skull"></i>',
                'biciestacionamiento': '<i class="far fa-home"></i>',
                'mala iluminación': '<i class="far fa-lightbulb"></i>'
            };

            {% for pin in pins %}
            
            var icon = L.divIcon({
                className: '{{pin.typeofpin}}',
                html: iconTypes['{{pin.typeofpin}}'],
                iconSize:[10,10],
                iconAnchor:[10,10],
            });
            L.marker([{{ pin.lat }}, {{ pin.lng }}], {icon: icon}).addTo(map)
                .bindPopup("<b>{{ pin.description }}</b><p>Fecha del reporte: {{pin.time}}</p><br><img src='{{ pin.photo }}'>");
            {% endfor %}

            //var live_location = map.locate()
            //if (navigator.geolocation) {
            //    navigator.geolocation.getCurrentPosition((position)) => {
                    // change map position
            //        };
            //    };
            //var youarehere = L.marker([latlng.lat, latlng.lng]).addTo(map);

            L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            //L.tileLayer('https://{s}.tile-cyclosm.openstreetmap.fr/cyclosm/{z}/{x}/{y}.png', {
                attribution: '© OpenStreetMap contributors'
            }).addTo(map);

            
            // Geolocation function
            function onLocationFound(e) {
                var radius = e.accuracy / 2;  // Accuracy of the location

                // Add a pin (marker) at the user's location
                user_marker = L.marker(e.latlng).addTo(map)
                    .bindPopup("Te detectamos en un radio de " + radius + " metros de este punto").openPopup();

                // Add a circle around the user's location
                user_radial = L.circle(e.latlng, radius).addTo(map);

                // Center the map on the user's location
                map.setView(e.latlng, 16);  // Adjust zoom level as needed
                //return marker, radial;
            }

            // Error handling for geolocation
            function onLocationError(e) {
                alert(e.message);
            }

            // Use Leaflet's built-in location detection
            map.on('locationfound', onLocationFound);
            map.on('locationerror', onLocationError);

            // Start the location detection
            map.locate({setView: true, maxZoom: 16});
            map.on('click', function(e) {
                var latlng = e.latlng;
                document.getElementById('lat').value = latlng.lat;
                document.getElementById('lng').value = latlng.lng;
                map.flyTo(e.latlng, zoom=18);
                //map.eachLayer( function (layer)) {
                //    console.log(layer);
                //    map.removeLayer(layer);
                //};
                //marker.remove();
                //radial.remove();
                user_marker.setLatLng(e.latlng).bindPopup('<button id="pinner-pop">Agregar bache-o-cosa</button>').openPopup();
                user_radial.remove();
                //setLanLng(e.latlng);
            });
            


            
        </script>
{% endblock %}